﻿package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Guchan Alkan
	$(CBI)*/
	public class Fauna extends Sprite
	{
		private var i:uint;
		private var timer:Timer = new Timer(40);
		
		private var bigBacteria:BigBacteria;
		private var smallBacteria:SmallBacteria;
		private var smallBacteriaArray:Array = new Array();
		private var weightArray:Array = ["closeness weight", "midsizedness weight"];
		
		private var txt:TextField = new TextField();
		
		private var flag:Boolean = false;
		private var selected:uint = 0;
		
		private var gui:Gui;
		
		public function Fauna()
		{
			for (i = 0; i < 10; i++)
			{
				var size:uint = 6 + Math.random() * 10;
				smallBacteria = new SmallBacteria(size, i);
				smallBacteriaArray.push(smallBacteria);
				smallBacteria.x = 25 + Math.random() * 450;
				smallBacteria.y = 25 + Math.random() * 450;
				addChild(smallBacteria);
			}
			
			gui = new Gui(this);
			gui.y = 441;
			addChild(gui);
			
			txt.width = 360;
			txt.x = 140;
			txt.y = 440;
			txt.selectable = false;
			addChild(txt);

			bigBacteria = new BigBacteria(this, 16, smallBacteriaArray);
			addChild(bigBacteria);
			
			gui.control.addEventListener(MouseEvent.CLICK, onControl);
			gui.prev.addEventListener(MouseEvent.CLICK, onPrev);
			gui.next.addEventListener(MouseEvent.CLICK, onNext);
			gui.increase.addEventListener(MouseEvent.CLICK, onIncrease);
			gui.decrease.addEventListener(MouseEvent.CLICK, onDecrease);
			
			txt.text = "Decision: " + bigBacteria.decision + "\n" + "Close(dom): " + bigBacteria.closeWeight + " * " + bigBacteria.closenessArray[bigBacteria.decision] + "\n" + "Midsized(dom): " + bigBacteria.midsizeWeight + " * " + bigBacteria.midSizeArray[bigBacteria.decision] + "\n" + "Total: " + bigBacteria.dummy;
			txt.setTextFormat(new TextFormat("Arial", 10, 0xFFFFFF, true));
			
			timer.addEventListener(TimerEvent.TIMER, onTimer);
		}
		
		private function onControl(evt:MouseEvent):void
		{
			if (!flag)
			{
				timer.start();
				flag = true;
			}
			else
			{
				timer.stop();
				flag = false;
			}
		}
		
		private function onPrev(evt:MouseEvent):void
		{
			if (selected != 0)
			{
				selected--;
				gui.changeSelectedTxt(weightArray[selected]);
			}
		}
		
		private function onNext(evt:MouseEvent):void
		{
			if (selected != weightArray.length - 1)
			{
				selected++;
				gui.changeSelectedTxt(weightArray[selected]);
			}
		}
		
		private function onIncrease(evt:MouseEvent):void
		{
			if (selected == 0)
			{
				if (bigBacteria.closeWeight < 10)
				{
					bigBacteria.closeWeight++;
					gui.changeWeightTxt(bigBacteria.closeWeight);
				}
			}
			else if (selected == 1)
			{
				if (bigBacteria.midsizeWeight < 10)
				{
					bigBacteria.midsizeWeight++;
					gui.changeWeightTxt(bigBacteria.midsizeWeight);
				}
			}
			txt.text = "Decision: " + bigBacteria.decision + "\n" + "Close(dom): " + bigBacteria.closeWeight + " * " + bigBacteria.closenessArray[bigBacteria.decision] + "\n" + "Midsized(dom): " + bigBacteria.midsizeWeight + " * " + bigBacteria.midSizeArray[bigBacteria.decision] + "\n" + "Total: " + bigBacteria.dummy;
			txt.setTextFormat(new TextFormat("Arial", 10, 0xFFFFFF, true));
		}
		
		private function onDecrease(evt:MouseEvent):void
		{
			if (selected == 0)
			{
				if (bigBacteria.closeWeight > 0)
				{
					bigBacteria.closeWeight--;
					gui.changeWeightTxt(bigBacteria.closeWeight);
				}
			}
			else if (selected == 1)
			{
				if (bigBacteria.midsizeWeight > 0)
				{
					bigBacteria.midsizeWeight--;
					gui.changeWeightTxt(bigBacteria.midsizeWeight);
				}
			}
			txt.text = "Decision: " + bigBacteria.decision + "\n" + "Close(dom): " + bigBacteria.closeWeight + " * " + bigBacteria.closenessArray[bigBacteria.decision] + "\n" + "Midsized(dom): " + bigBacteria.midsizeWeight + " * " + bigBacteria.midSizeArray[bigBacteria.decision] + "\n" + "Total: " + bigBacteria.dummy;
			txt.setTextFormat(new TextFormat("Arial", 10, 0xFFFFFF, true));
		}
		
		public function onTimer(evt:TimerEvent):void
		{
			for (i = 0; i < 10; i++)
			{
				smallBacteriaArray[i].wander();
			}
			bigBacteria.decide();
			txt.text = "Decision: " + bigBacteria.decision + "\n" + "Close(dom): " + bigBacteria.closeWeight + " * " + bigBacteria.closenessArray[bigBacteria.decision] + "\n" + "Midsized(dom): " + bigBacteria.midsizeWeight + " * " + bigBacteria.midSizeArray[bigBacteria.decision] + "\n" + "Total: " + bigBacteria.dummy;
			txt.setTextFormat(new TextFormat("Arial", 10, 0xFFFFFF, true));
		}
		
	}

}